#ifndef __OP5_LICENSE_LOGGING_H__
#define __OP5_LICENSE_LOGGING_H__

#include <stdio.h>
#include <errno.h>
#include <string.h>
#define OP5_LICENSE_DEBUG_ENVVAR "OP5_LICENSE_DEBUG"
#define clean_errno() (errno == 0 ? "None" : strerror(errno))
#define log_err(M, ...) license_log("[ERROR] (%s:%d: errno: %s) " M "\n", __FILE__, __LINE__, clean_errno(), ##__VA_ARGS__)
#define log_warn(M, ...) license_log("[WARNING] (%s:%d: errno: %s) " M "\n", __FILE__, __LINE__, clean_errno(), ##__VA_ARGS__)
#define log_info(M, ...) license_log("[INFO] (%s:%d) " M "\n", __FILE__, __LINE__, ##__VA_ARGS__)
#define log_debug(M, ...) license_log("[DEBUG] (%s:%d) " M "\n", __FILE__, __LINE__, ##__VA_ARGS__)

typedef void (*license_log_func)(const char *, ...);

extern license_log_func license_log;

#endif
